#!/usr/bin/perl 
# Encapsulates a simple make script
# requires latex and fig2dev

#use dbcode;
#
# Simply make a layout in XFig, setting various pieces of text to the
# following, and cdlabel will replace them with the real text.
#
# %track_XX		Track Title
# %album1, %album2	Album title, lines 1,2
# %artist1, %artist2	Artist lines 1,2
# %time_XX		Time for track  (00 is total time)
# _XX			Notation for track XX.
# %title_XX		Title for track XX
#
#




    
$filename = shift;       #data input
$LIB=shift;              #Template location
$outputfile1 = shift;    #front figure
$outputfile2 = shift;    #back figure

fig_creation();

exit;

sub fig_creation {
    open CDDATA, "$filename" or die "$!: $filename";
    
    $title = <CDDATA>; chomp $title;
    $artist = <CDDATA>; chomp $artist;
    $totaltime = <CDDATA>; chomp $totaltime;
    $numtracks = <CDDATA>; chomp $numtracks;
    $icon = <CDDATA>; chomp $icon;
    
    $index = 0;
    while (<CDDATA>) {
	$line = $_;
	chomp $line;
	$track_title[++$index] = $line;
	$line = <CDDATA>;
	chomp $line;
	$track_time[$index] = $line;
    }
    
    
    create_fig("$LIB/cd_front_template.fig", "$outputfile1");
    create_fig("$LIB/cd_back_template.fig", "$outputfile2");
    return;
}

sub create_fig {
    $srcname = shift;
    $destname = shift;
    open FIGORIG, "$srcname" or die "$!: $srcname";
    open FIGOUT, ">$destname" or die "$!: $destname";
    
    if ($title =~ /(.*)\/\/(.*)/) {
		$album1 = $1;
		$album2 = $2;
    } else {
		$album1 = $title;
		$album2 = "";
    }
    
    $album = $title;
    $album =~ s/\/\//: /g;		# Replace // with :
    
    if ($artist =~ /(.*)\/\/(.*)/) {
		$artist1 = $1;
		$artist2 = $2;
    } else {
		$artist1 = $artist;
		$artist2 = "";
    }
    
    $artist =~ s/\/\//: /g;		# Replace // with :
    
    while ($line = <FIGORIG>) {

		if ($line =~ /(\s+\d+\s*) %icon/) {
			printf FIGOUT "$1 %s\n", $icon;
			next;
		}

		if ($line =~ /(.*\d+\s*) %(.*)\\001/) { 
			$pre = $1;
			$tag = $2;
			
			
			if ($tag !~ /(.*)_(.*)/) {
				if ($tag eq "album1") {
					printf FIGOUT "$pre %s\\001\n", $album1;
					next;
				}
				
				if ($tag eq "album2") {
					printf FIGOUT "$pre %s\\001\n", $album2;
					next;
				}
				
				if ($tag eq "album") {
					printf FIGOUT "$pre %s\\001\n", $album;
					next;
				}
				
				if ($tag eq "artist1") {
					printf FIGOUT "$pre %s\\001\n", $artist1;
					next;
				}
				
				if ($tag eq "artist2") {
					printf FIGOUT "$pre %s\\001\n", $artist2;
					next;
				}
				
				if ($tag eq "artist") {
					printf FIGOUT "$pre %s\\001\n", $artist;
					next;
				}
				
				if ($tag eq "timetotal") {
					printf FIGOUT "$pre %s\\001\n", $totaltime;
					next;
				}
				

				
			} else {
				$key = $1;
				$id = $2;
				
				if ($id > $numtracks) {
					printf FIGOUT "$pre \\001\n";
					next;
				}
				
				if ($key eq "") {
					printf FIGOUT "$pre %d\\001\n", $id;
					next;
				}
				
				if ($key eq "title") {
					printf(FIGOUT "$pre %s\\001\n", $track_title[$id]), 
					next;
				}
				
				if ($key eq "time") {
					printf(FIGOUT "$pre %s\\001\n", $track_time[$id]);
					next;
				}
			}
			
		}
		printf FIGOUT "$line";
    }
    
    close FIGORIG;
    close FIGOUT;
}

